Subject: Re: [PATCH v2] net: bluetooth: hci_sock: Use 'const void *' instead of 'void *' for 2nd parameter of hci_test_bit()

From: Chen Gang S <[email-masked]>
Date: Thu, 05 Feb 2015 20:20:52 +0800

On 2/5/15 18:14, David Laight wrote:
> From: Chen Gang S [mailto:[email-masked]]
>> On 2/5/15 05:09, Marcel Holtmann wrote:
>>> Hi Sergei,
>>>
>>>>>> -static inline int hci_test_bit(int nr, void *addr)
>>>>>> +static inline int hci_test_bit(int nr, const void *addr)
>>>>>>  {
>>>>>>  	return *((__u32 *) addr + (nr >> 5)) & ((__u32) 1 << (nr & 31));
>>>>>>  }
>>>>
>>>>> Is there a 'standard' function lurking that will do the above.
>>>>> On x86 the cpus 'bit test' instruction will handle bit numbers
>>>>> greater than the word size - so it can be a single instruction.
>>>>
>>>>   Of course, there's test_bit().
>>>
>>> we did leave hci_test_bit in the code since there are some userspace facing
>>> API that we can not change. Remember that the origin of this code is
>>> from 2.4.6 kernel.
>>>
>>> So we can only change this if you can ensure not to break the userspace API.
>>> So might want to write unit tests to ensure working HCI filter before even
>>> considering touching this.
>>>
>>
>> For me, we have to remain hci_test_bit(), it is for "__u32 *" (which we
>> can not change). The common test_bit() is for "unsigned long *", in this
>> case, I guess it may cause issue under 64-bit environments.
> 
> Except that half the time you are passing a 'long *' and you haven't
> explained why this isn't broken on 64bit architectures.
>
 
Maybe we are misunderstanding with each other (excuse me for my pool
English). What I want to say is:

 - hci_test_bit() is OK (current implementation can not cause issue for
   64-bit machine).

 - But if we use test_bit(), I guess it will cause issue for 64-bit
   machine.

> Note that on LE systems the size of the accesses used to access a dense
> bit array don't matter. This is not true of BE systems.
> 

Yes, what you said above sounds reasonable to me, too.

Thanks.
-- 
Chen Gang

Open, share, and attitude like air, water, and life which God blessed